import java.io.*;
import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class HelloServer extends Activatable implements Hello {

	String whatToSay;
	int num = 0;      // allows us to see when server restarts

    public HelloServer(String str) 
           throws RemoteException, ActivationException, IOException {
        super(null, new MarshalledObject<String>(str), false, 0);
		whatToSay = str;
    }

    protected HelloServer(ActivationID id, MarshalledObject<String> data) 
		   throws RemoteException {
		super(id, 0);
		try {
		    whatToSay = data.get();
		}
        catch (Exception e) {
            System.out.println("HelloServer: " + e.getMessage());
            e.printStackTrace();
        }
    }
	
    public String sayHello() throws RemoteException {
		return whatToSay + " (" + ++num + ")";
    }

    public static void main(String[] args) throws Exception {

		System.setSecurityManager(new RMISecurityManager());

 		Properties props = new Properties(); 
   	    props.put("java.security.policy", 
	   	          "/home/wismueller/LEHRE/csp/CODE/BEISPIELE/RMI/HELLO-ACTIVATION/policy");

 		ActivationGroupDesc gdesc = new ActivationGroupDesc(props, null);
        ActivationGroupID gid = 
            ActivationGroup.getSystem().registerGroup(gdesc);
		ActivationGroup.createGroup(gid, gdesc, 0);

		Hello obj = new HelloServer("Hello World!!");
        
		Naming.rebind("rmi://localhost/Hello-Server", obj);
		System.out.println("Registered HelloServer");
    }
}
